module     p0_dubar_emnebarbbbar_d23h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d23h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram23_sign, shift => diagram23_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd23h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d23

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d23 = 0.0_ki
      d23 = (abb23n1+abb23n10*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3&
      &)-Q(4)*spvak3k2(4))+abb23n11*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4)&
      &)+abb23n12*(Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval&
      &5k2(4))+abb23n13*(Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)&
      &*spval6k2(4))+abb23n14*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3&
      &)-Q(4)*spval5k1(4))+abb23n15*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spva&
      &l6k1(3)-Q(4)*spval6k1(4))+abb23n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)&
      &*spvak2k1(3)-Q(4)*spvak2k1(4))+abb23n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)&
      &-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+abb23n4*(Q(1)*spvak2l6(1)-Q(2)*spvak2&
      &l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))+abb23n5*(Q(1)*spvak2l5(1)-Q(2)*s&
      &pvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))+abb23n6*(Q(1)*spvak3l6(1)-Q&
      &(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+abb23n7*(Q(1)*k1(1)-Q(&
      &2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb23n8*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)&
      &-Q(4)*l5(4))+abb23n8*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb23n&
      &9*(Q(1)*spvak3l5(1)-Q(2)*spvak3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3l5(4)))
      numerator = cmplx(real(d23, ki), aimag(d23), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd23h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d23

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d23 = 0.0_ki
      d23 = (abb23n1+abb23n10*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3&
      &)-Q(4)*spvak3k2(4))+abb23n11*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4)&
      &)+abb23n12*(Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval&
      &5k2(4))+abb23n13*(Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)&
      &*spval6k2(4))+abb23n14*(Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3&
      &)-Q(4)*spval5k1(4))+abb23n15*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spva&
      &l6k1(3)-Q(4)*spval6k1(4))+abb23n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)&
      &*spvak2k1(3)-Q(4)*spvak2k1(4))+abb23n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)&
      &-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+abb23n4*(Q(1)*spvak2l6(1)-Q(2)*spvak2&
      &l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))+abb23n5*(Q(1)*spvak2l5(1)-Q(2)*s&
      &pvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))+abb23n6*(Q(1)*spvak3l6(1)-Q&
      &(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+abb23n7*(Q(1)*k1(1)-Q(&
      &2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb23n8*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)&
      &-Q(4)*l5(4))+abb23n8*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb23n&
      &9*(Q(1)*spvak3l5(1)-Q(2)*spvak3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3l5(4)))

      numerator = cmplx(real(d23, ki), aimag(d23), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d23h0l1
