module     p0_dubar_emnebarbbbar_golem95h0
   use precision_golem, only: ki_gol => ki
   use p0_dubar_emnebarbbbar_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group0
   use p0_dubar_emnebarbbbar_d12h0l1, only: numerator_d12 => numerator_golem95
   use p0_dubar_emnebarbbbar_d12h0l1d, only: reconstruct_d12
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 12:
      if (tens_rec_by_derivatives) then
         call reconstruct_d12(coeffs)
      else
         call reconstruct2(numerator_d12, coeffs%coeffs_12)
      end if
   !------#] Diagram 12:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group1
   use p0_dubar_emnebarbbbar_d31h0l1, only: numerator_d31 => numerator_golem95
   use p0_dubar_emnebarbbbar_d31h0l1d, only: reconstruct_d31
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 31:
      if (tens_rec_by_derivatives) then
         call reconstruct_d31(coeffs)
      else
         call reconstruct2(numerator_d31, coeffs%coeffs_31)
      end if
   !------#] Diagram 31:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group2
   use p0_dubar_emnebarbbbar_d3h0l1, only: numerator_d3 => numerator_golem95
   use p0_dubar_emnebarbbbar_d3h0l1d, only: reconstruct_d3
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 3:
      if (tens_rec_by_derivatives) then
         call reconstruct_d3(coeffs)
      else
         call reconstruct3(numerator_d3, coeffs%coeffs_3)
      end if
   !------#] Diagram 3:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group3
   use p0_dubar_emnebarbbbar_d2h0l1, only: numerator_d2 => numerator_golem95
   use p0_dubar_emnebarbbbar_d2h0l1d, only: reconstruct_d2
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 2:
      if (tens_rec_by_derivatives) then
         call reconstruct_d2(coeffs)
      else
         call reconstruct3(numerator_d2, coeffs%coeffs_2)
      end if
   !------#] Diagram 2:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group4
   use p0_dubar_emnebarbbbar_d25h0l1, only: numerator_d25 => numerator_golem95
   use p0_dubar_emnebarbbbar_d25h0l1d, only: reconstruct_d25
   use p0_dubar_emnebarbbbar_d26h0l1, only: numerator_d26 => numerator_golem95
   use p0_dubar_emnebarbbbar_d26h0l1d, only: reconstruct_d26
   use p0_dubar_emnebarbbbar_d29h0l1, only: numerator_d29 => numerator_golem95
   use p0_dubar_emnebarbbbar_d29h0l1d, only: reconstruct_d29
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 25:
      if (tens_rec_by_derivatives) then
         call reconstruct_d25(coeffs)
      else
         call reconstruct3(numerator_d25, coeffs%coeffs_25)
      end if
   !------#] Diagram 25:
   !------#[ Diagram 26:
      if (tens_rec_by_derivatives) then
         call reconstruct_d26(coeffs)
      else
         call reconstruct2(numerator_d26, coeffs%coeffs_26)
      end if
   !------#] Diagram 26:
   !------#[ Diagram 29:
      if (tens_rec_by_derivatives) then
         call reconstruct_d29(coeffs)
      else
         call reconstruct2(numerator_d29, coeffs%coeffs_29)
      end if
   !------#] Diagram 29:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use p0_dubar_emnebarbbbar_config
   use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
   use p0_dubar_emnebarbbbar_d1h0l1, only: numerator_d1 => numerator_golem95
   use p0_dubar_emnebarbbbar_d1h0l1d, only: reconstruct_d1
   use p0_dubar_emnebarbbbar_d4h0l1, only: numerator_d4 => numerator_golem95
   use p0_dubar_emnebarbbbar_d4h0l1d, only: reconstruct_d4
   use p0_dubar_emnebarbbbar_d6h0l1, only: numerator_d6 => numerator_golem95
   use p0_dubar_emnebarbbbar_d6h0l1d, only: reconstruct_d6
   use p0_dubar_emnebarbbbar_d8h0l1, only: numerator_d8 => numerator_golem95
   use p0_dubar_emnebarbbbar_d8h0l1d, only: reconstruct_d8
   use p0_dubar_emnebarbbbar_d9h0l1, only: numerator_d9 => numerator_golem95
   use p0_dubar_emnebarbbbar_d9h0l1d, only: reconstruct_d9
   use p0_dubar_emnebarbbbar_d10h0l1, only: numerator_d10 => numerator_golem95
   use p0_dubar_emnebarbbbar_d10h0l1d, only: reconstruct_d10
   use p0_dubar_emnebarbbbar_d22h0l1, only: numerator_d22 => numerator_golem95
   use p0_dubar_emnebarbbbar_d22h0l1d, only: reconstruct_d22
   use p0_dubar_emnebarbbbar_d23h0l1, only: numerator_d23 => numerator_golem95
   use p0_dubar_emnebarbbbar_d23h0l1d, only: reconstruct_d23
   use p0_dubar_emnebarbbbar_d24h0l1, only: numerator_d24 => numerator_golem95
   use p0_dubar_emnebarbbbar_d24h0l1d, only: reconstruct_d24
   use p0_dubar_emnebarbbbar_d27h0l1, only: numerator_d27 => numerator_golem95
   use p0_dubar_emnebarbbbar_d27h0l1d, only: reconstruct_d27
   use p0_dubar_emnebarbbbar_d28h0l1, only: numerator_d28 => numerator_golem95
   use p0_dubar_emnebarbbbar_d28h0l1d, only: reconstruct_d28
   use p0_dubar_emnebarbbbar_d30h0l1, only: numerator_d30 => numerator_golem95
   use p0_dubar_emnebarbbbar_d30h0l1d, only: reconstruct_d30
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 1:
      if (tens_rec_by_derivatives) then
         call reconstruct_d1(coeffs)
      else
         call reconstruct3(numerator_d1, coeffs%coeffs_1)
      end if
   !------#] Diagram 1:
   !------#[ Diagram 4:
      if (tens_rec_by_derivatives) then
         call reconstruct_d4(coeffs)
      else
         call reconstruct2(numerator_d4, coeffs%coeffs_4)
      end if
   !------#] Diagram 4:
   !------#[ Diagram 6:
      if (tens_rec_by_derivatives) then
         call reconstruct_d6(coeffs)
      else
         call reconstruct2(numerator_d6, coeffs%coeffs_6)
      end if
   !------#] Diagram 6:
   !------#[ Diagram 8:
      if (tens_rec_by_derivatives) then
         call reconstruct_d8(coeffs)
      else
         call reconstruct2(numerator_d8, coeffs%coeffs_8)
      end if
   !------#] Diagram 8:
   !------#[ Diagram 9:
      if (tens_rec_by_derivatives) then
         call reconstruct_d9(coeffs)
      else
         call reconstruct2(numerator_d9, coeffs%coeffs_9)
      end if
   !------#] Diagram 9:
   !------#[ Diagram 10:
      if (tens_rec_by_derivatives) then
         call reconstruct_d10(coeffs)
      else
         call reconstruct2(numerator_d10, coeffs%coeffs_10)
      end if
   !------#] Diagram 10:
   !------#[ Diagram 22:
      if (tens_rec_by_derivatives) then
         call reconstruct_d22(coeffs)
      else
         call reconstruct1(numerator_d22, coeffs%coeffs_22)
      end if
   !------#] Diagram 22:
   !------#[ Diagram 23:
      if (tens_rec_by_derivatives) then
         call reconstruct_d23(coeffs)
      else
         call reconstruct1(numerator_d23, coeffs%coeffs_23)
      end if
   !------#] Diagram 23:
   !------#[ Diagram 24:
      if (tens_rec_by_derivatives) then
         call reconstruct_d24(coeffs)
      else
         call reconstruct3(numerator_d24, coeffs%coeffs_24)
      end if
   !------#] Diagram 24:
   !------#[ Diagram 27:
      if (tens_rec_by_derivatives) then
         call reconstruct_d27(coeffs)
      else
         call reconstruct2(numerator_d27, coeffs%coeffs_27)
      end if
   !------#] Diagram 27:
   !------#[ Diagram 28:
      if (tens_rec_by_derivatives) then
         call reconstruct_d28(coeffs)
      else
         call reconstruct2(numerator_d28, coeffs%coeffs_28)
      end if
   !------#] Diagram 28:
   !------#[ Diagram 30:
      if (tens_rec_by_derivatives) then
         call reconstruct_d30(coeffs)
      else
         call reconstruct2(numerator_d30, coeffs%coeffs_30)
      end if
   !------#] Diagram 30:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
end module p0_dubar_emnebarbbbar_golem95h0
