module     p0_dubar_emnebarbbbar_d30h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d30h1l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram30_sign, shift => diagram30_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd30h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = t4*abb30n8
      d30 = (abb30n13+t1*abb30n19+t2*t9+t2*abb30n2+t3*t9+t3*abb30n2+t4*abb30n21+&
      &t5*abb30n23+t6*abb30n27+t7*abb30n3+t8*abb30n4+abb30n11*(Q(1)*spval6k4(1)-&
      &Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))+abb30n12*(Q(1)*spvak2&
      &k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb30n14*(Q(1)*&
      &l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb30n15*(Q(1)*spval5k2(1)-Q(2)*s&
      &pval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+abb30n16*(Q(1)*Q(1)-Q(2)*Q(&
      &2)-Q(3)*Q(3)-Q(4)*Q(4))+abb30n17*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l&
      &5(4))+abb30n18*(Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*s&
      &pval6k2(4))+abb30n20*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-&
      &Q(4)*spvak3k2(4))+abb30n25*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6&
      &k1(3)-Q(4)*spval6k1(4))+t1*t2*abb30n5+t1*t3*abb30n5+t1*t5*abb30n22+t1*t6*&
      &abb30n26+t1*t7*abb30n6+t1*t8*abb30n9+t4*t5*abb30n24+t4*t6*abb30n28+t4*t7*&
      &abb30n7+t4*t8*abb30n10)
      numerator = cmplx(real(d30, ki), aimag(d30), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd30h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*spval6l5(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = t4*abb30n8
      d30 = (abb30n13+t1*abb30n19+t2*t9+t2*abb30n2+t3*t9+t3*abb30n2+t4*abb30n21+&
      &t5*abb30n23+t6*abb30n27+t7*abb30n3+t8*abb30n4+abb30n11*(Q(1)*spval6k4(1)-&
      &Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))+abb30n12*(Q(1)*spvak2&
      &k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb30n14*(Q(1)*&
      &l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb30n15*(Q(1)*spval5k2(1)-Q(2)*s&
      &pval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+abb30n16*(Q(1)*Q(1)-Q(2)*Q(&
      &2)-Q(3)*Q(3)-Q(4)*Q(4))+abb30n17*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l&
      &5(4))+abb30n18*(Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*s&
      &pval6k2(4))+abb30n20*(Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-&
      &Q(4)*spvak3k2(4))+abb30n25*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6&
      &k1(3)-Q(4)*spval6k1(4))+t1*t2*abb30n5+t1*t3*abb30n5+t1*t5*abb30n22+t1*t6*&
      &abb30n26+t1*t7*abb30n6+t1*t8*abb30n9+t4*t5*abb30n24+t4*t6*abb30n28+t4*t7*&
      &abb30n7+t4*t8*abb30n10)

      numerator = cmplx(real(d30, ki), aimag(d30), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d30h1l1
