module     p0_dubar_emnebarbbbar_d24h2l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity2/d24h2l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t8 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))
      t9 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t10 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4)&
      &)
      d24 = (abb24n1+t1*abb24n19+t2*abb24n2+t3*abb24n3+t4*abb24n4+t5*abb24n5+t6*&
      &abb24n6+t7*abb24n7+t1*t10*abb24n27+t1*t5*abb24n23+t1*t7*abb24n15+t1*t8*ab&
      &b24n10+t1*t9*abb24n24+t10*t7*abb24n30+t10*t8*abb24n25+t10*t9*abb24n29+t10&
      &*abb24n26*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+t10*abb24n28*(Q(1&
      &)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+t10*abb&
      &24n9*(Q(1)*spvak1l6(1)-Q(2)*spvak1l6(2)-Q(3)*spvak1l6(3)-Q(4)*spvak1l6(4)&
      &)+t2*t7*abb24n14+t2*t9*abb24n20+t3*t7*abb24n13+t3*t9*abb24n21+t4*t7*abb24&
      &n12+t4*t9*abb24n22+t5*t6*abb24n16+t5*t7*abb24n8+t7*abb24n11*(Q(1)*spval5k&
      &2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+t7*abb24n17*(Q(1&
      &)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4))+t8*t9*a&
      &bb24n18+t5*t6*t8*abb24n31)
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t8 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))
      t9 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t10 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4)&
      &)
      d24 = (abb24n1+t1*abb24n19+t2*abb24n2+t3*abb24n3+t4*abb24n4+t5*abb24n5+t6*&
      &abb24n6+t7*abb24n7+t1*t10*abb24n27+t1*t5*abb24n23+t1*t7*abb24n15+t1*t8*ab&
      &b24n10+t1*t9*abb24n24+t10*t7*abb24n30+t10*t8*abb24n25+t10*t9*abb24n29+t10&
      &*abb24n26*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+t10*abb24n28*(Q(1&
      &)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+t10*abb&
      &24n9*(Q(1)*spvak1l6(1)-Q(2)*spvak1l6(2)-Q(3)*spvak1l6(3)-Q(4)*spvak1l6(4)&
      &)+t2*t7*abb24n14+t2*t9*abb24n20+t3*t7*abb24n13+t3*t9*abb24n21+t4*t7*abb24&
      &n12+t4*t9*abb24n22+t5*t6*abb24n16+t5*t7*abb24n8+t7*abb24n11*(Q(1)*spval5k&
      &2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4))+t7*abb24n17*(Q(1&
      &)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4))+t8*t9*a&
      &bb24n18+t5*t6*t8*abb24n31)

      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d24h2l1
