module     p0_dubar_emnebarbbbar_d31h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity3/d31h3l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram31_sign, shift => diagram31_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd31h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d31
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d31 = 0.0_ki
      t1 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t2 = (Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))
      t3 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      d31 = (abb31n12+t1*abb31n10+t2*abb31n14+t3*abb31n17+t4*abb31n18+t5*abb31n2&
      &+abb31n11*(Q(1)*spvak3l5(1)-Q(2)*spvak3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3&
      &l5(4))+abb31n13*(Q(1)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*&
      &spvak3l6(4))+abb31n5*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb31n&
      &6*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))+abb31n7*(Q(1)*spval5l6(1)&
      &-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))+abb31n8*(Q(1)*Q(1)-Q&
      &(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb31n9*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q&
      &(4)*k2(4))+t1*t3*abb31n20+t1*t4*abb31n16+t1*t5*abb31n4+t2*t3*abb31n19+t2*&
      &t4*abb31n15+t2*t5*abb31n3)
      numerator = cmplx(real(d31, ki), aimag(d31), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd31h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d31
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d31 = 0.0_ki
      t1 = (Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spvak2l6(3)-Q(4)*spvak2l6(4))
      t2 = (Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))
      t3 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      d31 = (abb31n12+t1*abb31n10+t2*abb31n14+t3*abb31n17+t4*abb31n18+t5*abb31n2&
      &+abb31n11*(Q(1)*spvak3l5(1)-Q(2)*spvak3l5(2)-Q(3)*spvak3l5(3)-Q(4)*spvak3&
      &l5(4))+abb31n13*(Q(1)*spvak3l6(1)-Q(2)*spvak3l6(2)-Q(3)*spvak3l6(3)-Q(4)*&
      &spvak3l6(4))+abb31n5*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb31n&
      &6*(Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))+abb31n7*(Q(1)*spval5l6(1)&
      &-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))+abb31n8*(Q(1)*Q(1)-Q&
      &(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb31n9*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q&
      &(4)*k2(4))+t1*t3*abb31n20+t1*t4*abb31n16+t1*t5*abb31n4+t2*t3*abb31n19+t2*&
      &t4*abb31n15+t2*t5*abb31n3)

      numerator = cmplx(real(d31, ki), aimag(d31), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d31h3l1
